# -*- coding: utf-8 -*-
import os
import pymongo
from pymongo import MongoClient
import sys
import pylab as plt
import pickle
import unicodedata


client = MongoClient()
db = client.lastfm_database
albums = db.albums


G = nx.Graph()
weights = {}
tags_time = {}
yy_prec = 1905
G_prec = None
albums_count = 0.0

for record in albums_cleaned.find().sort([(u'release date', pymongo.ASCENDING)]):
    
    album = tuple(record["name"])
    tags = record["tags"]
    yy = record["release date"]
      
    
    if yy != yy_prec:
        G_prec = G.copy()    
        nx.set_edge_attributes(G_prec,"weight", weights)
        n = G_prec.number_of_nodes()

        n_albums = {}
        tags_time_aux = {}
        for n in G_prec.nodes():
            tags_time_aux[n] =  tags_time[n]
            n_albums[n] = albums_count
        
        nx.set_node_attributes(G_prec, "year", tags_time_aux)
        nx.set_node_attributes(G_prec, "albums_count", n_albums)
        nx.write_gexf(G_prec, "./cooccurrence_net_"+str(yy_prec)+".gexf")
        
        yy_prec = yy
        print yy_prec
        G = nx.Graph()
        weights = {}
        albums_count=0.0
        
    albums_count+=1.0
    
    for tag in tags:
        try: 
            foo = tags_time[tag]
        except KeyError:
            tags_time[tag] = yy
            G.add_node(tag)

    for i in range(len(tags)):
        tag1 = tags[i]
        for j in range(i+1, len(tags)):
            tag2 = tags[j]
            e = (tag1, tag2)
            try: 
                weights[e]+=1.0
            except KeyError: 
                weights[e] = 1.0
                G.add_edge(tag1, tag2)

    
