# -*- coding: utf-8 -*-
import os
import pymongo
from pymongo import MongoClient
from bson.son import SON
import json

client = MongoClient()
db = client.lastfm_database
albums = db.albums

f=open('./albums_time_dump.json', "r")
counter=0
while True:
    try:
        record = json.loads(f.readline())
        albums.insert(record)
    except ValueError: break
f.close()

albums.create_index([(u'release date', pymongo.ASCENDING)])